analyze.set <-
function (x = test.set) 
{
    if (class(x) != "list") 
        stop("x must be a list of sets!")
    n.x <- length(x)
    n.com <- n.x * (n.x - 1)/2
    res <- data.frame(id.1 = rep(NA, n.com), id.2 = NA, n.1 = NA, 
        n.2 = NA, n.int = NA, n.uni = NA, comparison = "", s.1 = "", 
        s.2 = "")
    k <- 0
    for (i in c(1:(n.x - 1))) {
        for (j in c((i + 1):n.x)) {
            k <- k + 1
            res$id.1[k] <- i
            res$id.2[k] <- j
            res$n.1[k] <- length(x[[i]])
            res$n.2[k] <- length(x[[j]])
            res$n.int[k] <- length(intersect(unlist(x[[i]]), 
                unlist(x[[j]])))
            res$n.uni[k] <- length(union(unlist(x[[i]]), unlist(x[[j]])))
            res$s.1[k] <- paste(x[[i]], collapse = ", ")
            res$s.2[k] <- paste(x[[j]], collapse = ", ")
            res$s.1[k] <- paste("{", res$s.1[k], "}", sep = "")
            res$s.2[k] <- paste("{", res$s.2[k], "}", sep = "")
            if (res$n.int[k] == 0) 
                res$comparison[k] <- "disjoint"
            if (res$n.int[k] > 0) {
                s1ms2 <- setdiff(unlist(x[[i]]), unlist(x[[j]]))
                s2ms1 <- setdiff(unlist(x[[j]]), unlist(x[[i]]))
                if (length(s1ms2) == 0) 
                  res$comparison[k] <- "s2.includes.s1"
                if (length(s2ms1) == 0) 
                  res$comparison[k] <- "s1.includes.s2"
                if ((length(s1ms2) > 0) & (length(s2ms1) > 0)) 
                  res$comparison[k] <- "intersected"
                if (res$n.int[k] == res$n.uni[k]) 
                  res$comparison[k] <- "identical"
            }
        }
    }
    res
}
