analyze2sets <-
function (x = test.set[1:3], y = test.set[2:5], only.identical = FALSE) 
{
    if (class(x) != "list") 
        stop("x must be a list of sets!")
    if (class(y) != "list") 
        stop("y must be a list of sets!")
    n.x <- length(x)
    n.y <- length(y)
    n.com <- n.x * n.y
    res <- data.frame(id.x = rep(NA, n.com), id.y = NA, n.x = NA, 
        n.y = NA, n.int = NA, n.uni = NA, comparison = "", s.x = "", 
        s.y = "")
    k <- 0
    for (i in c(1:n.x)) {
        for (j in c(1:n.y)) {
            k <- k + 1
            res$id.x[k] <- i
            res$id.y[k] <- j
            res$n.x[k] <- length(x[[i]])
            res$n.y[k] <- length(y[[j]])
            res$n.int[k] <- length(intersect(unlist(x[[i]]), 
                unlist(y[[j]])))
            res$n.uni[k] <- length(union(unlist(x[[i]]), unlist(y[[j]])))
            res$s.x[k] <- paste(x[[i]], collapse = ", ")
            res$s.y[k] <- paste(y[[j]], collapse = ", ")
            res$s.x[k] <- paste("{", res$s.x[k], "}", sep = "")
            res$s.y[k] <- paste("{", res$s.y[k], "}", sep = "")
            if (res$n.int[k] == 0) 
                res$comparison[k] <- "disjoint"
            if (res$n.int[k] > 0) {
                sxmsy <- setdiff(unlist(x[[i]]), unlist(y[[j]]))
                symsx <- setdiff(unlist(y[[j]]), unlist(x[[i]]))
                if (length(sxmsy) == 0) 
                  res$comparison[k] <- "sy.includes.sx"
                if (length(symsx) == 0) 
                  res$comparison[k] <- "sx.includes.sy"
                if ((length(sxmsy) > 0) & (length(symsx) > 0)) 
                  res$comparison[k] <- "intersected"
                if (res$n.int[k] == res$n.uni[k]) 
                  res$comparison[k] <- "identical"
            }
        }
    }
    if (only.identical == TRUE) {
        res <- res[res$comparison == "identical", c(1:3, 8)]
        names(res)[3:4] <- c("n.ele", "cluster")
    }
    res
}
