dend.topo <-
function (x = hclust(dist(matrix(c(1:50)/10, nrow = 10, ncol = 5, 
    dimnames = list(LETTERS[1:10], c(1:5)))))) 
{
    aux.fun <- function(t.m, clu.by.lab, is.clu.done, need2do, 
        n.clu, t.l) {
        for (i in 1:n.clu) {
            if ((is.element(i, need2do)) & (t.m$V1[i] < 0) & 
                (is.element(t.m$V2[i], is.clu.done))) {
                clu.by.lab[[i]] <- c(t.l[-t.m$V1[i]], clu.by.lab[[t.m$V2[i]]])
                t.m$class[i] <- length(clu.by.lab[[i]])
                is.clu.done <- t.m$clu[!is.na(t.m$class)]
                need2do <- setdiff(c(1:n.clu), is.clu.done)
            }
        }
        for (i in 1:n.clu) {
            if ((is.element(i, need2do)) & (is.element(t.m$V1[i], 
                is.clu.done)) & (is.element(t.m$V2[i], is.clu.done))) {
                clu.by.lab[[i]] <- c(clu.by.lab[[t.m$V1[i]]], 
                  clu.by.lab[[t.m$V2[i]]])
                t.m$class[i] <- length(clu.by.lab[[i]])
                is.clu.done <- t.m$clu[!is.na(t.m$class)]
                need2do <- setdiff(c(1:n.clu), is.clu.done)
            }
        }
        list(t.m, clu.by.lab)
    }
    if (class(x) != "hclust") {
        stop("The argument MUST be of class \"hclust\"! Try again.")
    }
    t.l <- x$labels
    t.m <- as.data.frame(x$merge)
    n.clu <- nrow(t.m)
    is.clu.done <- rep(FALSE, n.clu)
    t.m$clu <- c(1:n.clu)
    t.m$class <- NA
    t.m$height <- x$height
    clu.by.lab <- vector("list", n.clu)
    names(clu.by.lab) <- c(1:n.clu)
    temp.is1 <- (t.m$V1 < 0) & (t.m$V2 < 0)
    for (i in 1:n.clu) {
        if (temp.is1[i] == TRUE) {
            clu.by.lab[[i]] <- c(x$labels[-t.m$V1[i]], x$labels[-t.m$V2[i]])
            is.clu.done[i] <- TRUE
            t.m$class[i] <- 2
        }
    }
    is.clu.done <- t.m$clu[!is.na(t.m$class)]
    need2do <- setdiff(c(1:n.clu), is.clu.done)
    for (n.calls in 1:555) {
        temp.aux <- aux.fun(t.m = t.m, clu.by.lab = clu.by.lab, 
            is.clu.done = is.clu.done, need2do = need2do, n.clu = n.clu, 
            t.l = t.l)
        t.m <- temp.aux[[1]]
        clu.by.lab <- temp.aux[[2]]
        is.clu.done <- t.m$clu[!is.na(t.m$class)]
        need2do <- setdiff(c(1:n.clu), is.clu.done)
        if (length(need2do) == 0) {
            break
        }
    }
    t.m <- temp.aux[[1]]
    clu.by.lab <- temp.aux[[2]]
    res <- list(t.m, clu.by.lab)
    names(res) <- c("original", "clusters")
    res
}
